# -*- coding: utf-8  -*-
from tweepy import Stream
from tweepy import OAuthHandler
from tweepy.streaming import StreamListener
import time
import threading
import json
import hashlib
import re
import numpy as np
import matplotlib
import matplotlib.pyplot as plt
from mpl_toolkits.basemap import Basemap

#Twitter-Keys (bekommt man aus der App und ermoeglicht Nutzung der Daten)
consumer_key='PRvi1ybLrsCn1GciL0MyMrz6I'
consumer_secret= 'N5GgDenfbWvMcDMxenTrnvwCqtzEFELcBMjGb8ayYem1HanPr9'
access_token= '936241031720374273-c87uxet8J3uBAsVsbAFfcYrlNBm9T3G'
access_secret= 'HU7UP7XCyiibwn3mcOl2MZn060ROqdTaWc9khRWIPnYJ3'
#Authentifizierung
auth = OAuthHandler(consumer_key, consumer_secret)
auth.set_access_token(access_token, access_secret)


rt_pattern = re.compile('^RT(\s)*@\w+')   


#Klasse Listener 
class listener(StreamListener):

	def on_data(self, data): #wird automatisch bei Twitter-Stream aufgerufen 
		


			global d, loc, tweet_list #globale Variablen
			try:
			
				d = json.loads(data) #json format in python umgewandelt 
				tweet = d['text'] #der "Text" aus json wird in Variable tweet gespeichert
				m = rt_pattern.match(tweet) 
				
				if not m: #Fehler auffangen
					
					try:
						tweet = d['extended_tweet']['full_text']
					except:
						pass
					
				
				
					digest = hashlib.md5(tweet.encode('utf8')).hexdigest() #damit keine Fehler auftreten 
					if (digest not in hashset):
						print tweet
						hashset.add(digest)
						
						new = {} #es wird ein Woertbuch erstellt und nachfolgend die Daten aus dem Json Object in new eingespeichert
						
						new['text'] = tweet 
						new['user'] = {'id':d['user']['id'],'name':d['user']['name'],'description':d['user']['description'],'location':d['user']['location']}
						new['timestamp_ms'] = d['timestamp_ms']
						new['created_at'] = d['created_at']
						
						#es wird als Koordinaten in new entweder die Koordinaten der angegebenen Stadt oder falls vorhanden sogar die genauen Koordinaten gespeichert
						if d['place']: 
							
							if d['place']['place_type']==u'city':
								coords = np.mean(np.array(d['place']['bounding_box']['coordinates'])[0,:,:], axis=0)
								new['coordinates'] = list(coords)
	
						if d['coordinates']:
							if d['coordinates']['type']==u'Point':
								new['coordinates'] = d['coordinates']['coordinates']
							
						saveFile = open(FILENAME , 'a')
						saveFile.write(json.dumps(new))
						saveFile.write('\n')
						saveFile.close()
						with tweet_list_lock:
							tweet_list.append(new) #new zur Tweetsliste hinzugefuegt
				return True


			except BaseException as e:
				print ("Error on_data...... %s"% str(e))
				#time.sleep(2)

########################################################################

#Karte erstellen

fig= plt.figure(figsize=(14,10)) #mapsize

plt.title("Tweets around the world") #Titel

earth= Basemap(projection='cyl') 
earth.drawcoastlines(color='0.50',linewidth=0.25)

#JSON
FILENAME = 'tweets_Trump.json' 

hashset= set()

tweet_list = [] #tweetlist erzeugt
f = open(FILENAME,"w")

# es werden die Tweets im json-file zur Tweetlist hinzugefuegt:
with open(FILENAME,"r") as f:
		for line in f:
			tweet_list.append(json.loads(line))


#Punkte anzeigen 
def punkte(max_plots = 5): # im Parameter wird festgelegt wie viele Punkte auf einmal angezeigt werden
	zaehler=0 #wie viele schon angezeigt wurden 
	all_scatter_plots = [] #Liste von angezeigten Punkten
	transparent=0
	while True:
		with tweet_list_lock:
			if len(tweet_list)> zaehler:  #wenn mehr Tweets in tweetslist gespeichert wurden als angezeigt
				temp=len(tweet_list)-zaehler # wie viele noch neu angezeigt werden muessen
				#Liste von Längen- und Breitengrad
				lon = [] 
				lat = []
				for d in tweet_list[-temp:]: #die Koordinaten (falls vorhanden) der neuen Tweets werden in lon und lat gespeichert
					if 'coordinates' in d:
						lon.append(d['coordinates'][0])
						lat.append(d['coordinates'][1])	
						
				zaehler=zaehler+temp #anpassung des Zaehlers
				p = plt.scatter( [earth(lo,la)[0] for lo,la in zip(lon,lat)],[earth(lo,la)[1]for lo,la in zip(lon,lat)], edgecolors = (0,0,1,1),facecolors=(0,0,0.3,0.25),zorder=10) #Punkte anzeigen
				all_scatter_plots.append(p) 
				#if len(all_scatter_plots)>max_plots: 
					#print len(all_scatter_plots)
					#all_scatter_plots[transparent].set_alpha(0)
					#transparent+=1
				
				#es werdem die Punkte am Anfang der Liste auf transparent gestellt sodass nur 5 zu sehen sind	
				if len(all_scatter_plots)>max_plots and (temp > 0) :  	
					while temp>0:
						all_scatter_plots[transparent].set_alpha(0)
						transparent+=1
						temp-=1
						
				plt.pause(0.001)
				plt.gcf().canvas.draw() #Bild wird "geupdated"
			time.sleep(0.001)
		

#Threading

tweet_list_lock = threading.Lock() # Liste kann locked oder unlocked sein um zu vermeiden dass die beiden threads gleichzeitig zugreifen 

threads= [] #Liste fuer threads erzeugt
t=threading.Thread(target=punkte) # Thread erzeugt der Punkte Funktion immer wieder aufruft
threads.append(t) #Punkte-Thread wird in Liste eingefuegt
t.start() #Punkte-Thread wird gestartet

auth = OAuthHandler(consumer_key, consumer_secret) 
auth.set_access_token(access_token, access_secret)

#twitterStream

# Klasse listener aufgerufen und fuer jeden Tweet Funktion on_data ausgefuehrt
# Filter waehlen 
twitterStream = Stream(auth, listener()) 
#t2=threading.Thread(target = twitterStream.filter, kwargs= {'locations':[-180,-90,180,90]}) #damit koennte man einfach nach allen Tweets auf der Welt filtern (gut wenn man für Test mehr Punkte braucht)
t2=threading.Thread(target = twitterStream.filter, kwargs= {'track':["Trump"]}) # Thread erzeugt für Twitter-Stream
t2.start()#zweites Thread wird auch gestartet

plt.show() #anzeigen
